/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "CoreMinimal.h"
#include "Engine/CanvasRenderTarget2D.h"
#include "Materials/MaterialInstanceDynamic.h"

#include "MixCastOpaqueCanvas.generated.h"

class AExpCamera;

UCLASS()
class MIXCAST_API UMixCastOpaqueCanvas : public UCanvasRenderTarget2D
{
	GENERATED_UCLASS_BODY()

public:
	UMixCastOpaqueCanvas();
	void Initialize(UTextureRenderTarget2D* HdrOpaqueTex, UTextureRenderTarget2D* FinalOpaqueTex);

protected:
	UFUNCTION()
	void MergeTargets(UCanvas* Canvas, int32 Width, int32 Height);

private:
	UPROPERTY(VisibleAnywhere, Category = "Materials")
		UMaterialInstanceDynamic* combineMat;
};