#pragma once

#include "WatchedUnrealSharedTexture.h"
#include "WatchedUnrealSharedTexture_D3D11.h"
#include "WatchedUnrealSharedTexture_D3D12.h"
#include "Utility/ProjectUtils.hpp"

#include "CoreMinimal.h"
#include "Engine/Texture2D.h"

#include "../../../MixCastLog.h"

EPixelFormat WatchedUnrealSharedTexture::GetUnrealFormatFromDirectXFormat(unsigned int format)
{
	switch (format)
	{
	default:
	case 0:
	case 2:
		return PF_A32B32G32R32F;
	case 10:
		return PF_FloatRGBA;
	case 41:
		return PF_R32_FLOAT;
	}
}

WatchedUnrealSharedTexture* WatchedUnrealSharedTexture::Create(HANDLE remoteTexHandle)
{
	switch (ProjectUtils::GetGraphicsType())
	{
	case mixcast::data::ExpGraphicsType::DX11:
		return new WatchedUnrealSharedTexture_D3D11(remoteTexHandle);
	default:
		return NULL;
	}
}
WatchedUnrealSharedTexture* WatchedUnrealSharedTexture::Create(HANDLE srcProcId, HANDLE remoteTexHandle)
{
	switch (ProjectUtils::GetGraphicsType())
	{
	case mixcast::data::ExpGraphicsType::DX11:
		return new WatchedUnrealSharedTexture_D3D11(srcProcId, remoteTexHandle);
#if MIXCAST_D3D12
	case mixcast::data::ExpGraphicsType::DX12:
		return new WatchedUnrealSharedTexture_D3D12(srcProcId, remoteTexHandle);
#endif
	default:
		return NULL;
	}
}