#pragma once

#include "MixCast.h"
#include "MixCastSdkActor.h"

#include "CoreMinimal.h"
#include "CoreGlobals.h"
#include "Misc/CoreDelegates.h"
#include "Kismet/GameplayStatics.h"

class MixCastSdkInitializer
{
private:
	const float InitializedCheckDelay = 1.0f;

	FDelegateHandle EndFrameDel;

	void Tick()
	{
		FMixCast* mod = (FMixCast*)&IMixCast::Get();
		UWorld* world = GEngine->GetWorldContextFromGameViewport(GEngine->GameViewport)->World();
		if (!mod->HasSdkActor() && 
			world != nullptr && world->WorldType != EWorldType::Editor && UGameplayStatics::GetRealTimeSeconds(world) > InitializedCheckDelay)
			{
				AActor* sdkActor = UGameplayStatics::BeginDeferredActorSpawnFromClass(world, AMixCastSdkActor::StaticClass(), FTransform::Identity);
				UGameplayStatics::FinishSpawningActor(sdkActor, FTransform::Identity);
		}
	}
public:
	MixCastSdkInitializer() 
	{
		EndFrameDel = FCoreDelegates::OnEndFrame.AddRaw(this, &MixCastSdkInitializer::Tick);
	}
	~MixCastSdkInitializer()
	{
		FCoreDelegates::OnEndFrame.Remove(EndFrameDel);
	}
};

